/*
 *   Copyright (C)2004-2011 Sir Pustekuchen
 *
 *   Author   :  Sir Pustekuchen
 *   Home     :  http://birth-of-the-empires.de
 *
 */
#pragma once

class CMainDlg;
#include "Resource.h"
#include "NewGamePage.h"
#include "ChooseRacePage.h"
#include "PlayGamePage.h"
#include "Network.h"
#include "PeerData.h"
#include "BotEServer.h"
#include "BotEClient.h"
class CBotf2Doc;
// CMainDlg

/**
 * Testdialog, der das Starten des Servers, Verbinden eines Clients und die Auswahl des
 * zu spielenden Volkes erlaubt.
 *
 * @author CBot
 * @version 0.0.2
 */
class CMainDlg : public CPropertySheet, public network::CClientListener, public network::CServerListener
{
	DECLARE_DYNAMIC(CMainDlg)

private:
	CNewGamePage *m_pNewGame;
	CChooseRacePage *m_pChooseRace;
//	CPlayGamePage *m_pPlayGame;
	CBotf2Doc *m_pDoc;
		
public:
	CMainDlg(CBotf2Doc* pDoc);
	virtual ~CMainDlg();

	CBotf2Doc *GetServerDocument() {return m_pDoc;}
	CBotf2Doc *GetClientDocument() {return m_pDoc;}

protected:
	DECLARE_MESSAGE_MAP()

private:
	virtual BOOL OnInitDialog();

	afx_msg LRESULT OnUserMsg(WPARAM wParam, LPARAM lParam);

	// bentigte Handler fr Server-Ereignisse
	virtual void OnServerSocketError(int nError);

	// bentigte Handler fr Client-Ereignisse
	virtual void OnClientSocketError(int nError);
	virtual void OnClientChangedRaces();
	virtual void OnClientDisconnected();

	virtual void OnBeginGame(network::CBeginGame *pMsg);
	virtual void OnPrepareGame();
	virtual void OnNextRound(network::CNextRound *pMsg);
	virtual void OnCalculateGame();
	virtual void OnChatMsg(network::CChatMsg *pMsg);

	virtual void OnClientLost(const CString &) {}
};
