/*
 *   Copyright (C)2004-2011 Sir Pustekuchen
 *
 *   Author   :  Sir Pustekuchen
 *   Home     :  http://birth-of-the-empires.de
 *
 */
#pragma once
#include "Options.h"
#include <map>

/**
 * Diese Klasse beinhaltet bestimmte Prioritten, welche im Zusammenhang des Geheimdienstes stehen. Zustzlich finden
 * hier die Berechnungen der KI fr den Geheimdienst statt.
 */
class CBotf2Doc;
class CIntelAI
{
public:
	/// Konstruktor
	CIntelAI(void);
	
	/// Destruktor
	~CIntelAI(void);

	// Zugriffsfunktionen
	/// Funktion gibt die Prioritt fr den Geheimdienst fr eine Rasse zurck.
	/// @param race gewnschte Rasse
	BYTE GetIntelPrio(const CString& sRace) {return m_byIntelPrio[sRace];}

	// sonstige Funktionen
	/// Funktion berechnet den Umgang mit dem Geheimdienst fr die KI. Sie trifft Zuteilungen fr die einzelnen Rassen.
	/// @param pDoc Zeiger auf das Dokument
	void CalcIntelligence(CBotf2Doc* pDoc);

	/// Resetfunktion fr ein CIntelAI-Objekt.
	void Reset(void);

private:
	// Attribute
	std::map<CString, BYTE> m_byIntelPrio;		///< beinhaltet die Prioritt zum Bau von Geheimdienstgebuden


};
