#include "stdafx.h"
#include "RaceDesign.h"

IMPLEMENT_SERIAL (CRaceDesign, CObject, 1)

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////
CRaceDesign::CRaceDesign(void)
{
	Reset();
}

CRaceDesign::~CRaceDesign(void)
{
}

///////////////////////////////////////////////////////////////////////
// Speichern / Laden
///////////////////////////////////////////////////////////////////////
void CRaceDesign::Serialize(CArchive &ar)		
{
	CObject::Serialize(ar);
	
	// wenn gespeichert wird
	if (ar.IsStoring())
	{
		ar << m_clrSector;		// Sektormarkierung
		ar << m_clrSmallBtn;	// Schriftfarbe fr kleinen Button
		ar << m_clrLargeBtn;	// Schriftfarbe fr groen Button
		ar << m_clrSmallText;	// Schriftfarbe fr kleinen Text
		ar << m_clrNormalText;	// Schriftfarbe fr normalen Text
		ar << m_clrSecondText;	// Zweitfarbe fr normalen Text

		ar << m_clrGalaxySectorText;// Farbe der Systemnamen auf der Galaxiemap

		ar << m_clrListMarkTextColor;	// Farbe fr Text wenn dieser markiert ist
		ar << m_clrListMarkPenColor;	// Farbe fr Umrandung bei Markierung eines Eintrags in einer Liste
		ar << m_clrRouteColor;			// Farbe der Handels- und Ressourcenrouten

		for (int i = 0; i < 6; i++)
		{
			ar << m_byGDIFontSize[i];		// Fontgren fr GDI Darstellung
			ar << m_byGDIPlusFontSize[i];	// Fontgren fr GDI+ Darstellung
		}
		ar << m_sFontName;		// Name der Schriftart
	}
	// wenn geladen wird
	else if (ar.IsLoading())
	{
		ar >> m_clrSector;		// Sektormarkierung
		ar >> m_clrSmallBtn;	// Schriftfarbe fr kleinen Button
		ar >> m_clrLargeBtn;	// Schriftfarbe fr groen Button
		ar >> m_clrSmallText;	// Schriftfarbe fr kleinen Text
		ar >> m_clrNormalText;	// Schriftfarbe fr normalen Text
		ar >> m_clrSecondText;	// Zweitfarbe fr normalen Text

		ar >> m_clrGalaxySectorText; // Farbe der Systemnamen auf der Galaxiemap

		ar >> m_clrListMarkTextColor;	// Farbe fr Text wenn dieser markiert ist
		ar >> m_clrListMarkPenColor;	// Farbe fr Umrandung bei Markierung eines Eintrags in einer Liste
		ar >> m_clrRouteColor;			// Farbe der Handels- und Ressourcenrouten

		for (int i = 0; i < 6; i++)
		{
			ar >> m_byGDIFontSize[i];		// Fontgren fr GDI Darstellung
			ar >> m_byGDIPlusFontSize[i];	// Fontgren fr GDI+ Darstellung
		}
		ar >> m_sFontName;		// Name der Schriftart
	}
}

//////////////////////////////////////////////////////////////////////
// sonstige Funktionen
//////////////////////////////////////////////////////////////////////

/// Funktion zum zurcksetzen aller Werte auf Ausgangswerte.
void CRaceDesign::Reset(void)
{
	m_clrSector		= RGB(200,200,200);	// Sektormarkierung
	m_clrSmallBtn	= 0;				// Schriftfarbe fr kleinen Button
	m_clrLargeBtn	= 0;				// Schriftfarbe fr groen Button
	m_clrSmallText	= 0;				// Schriftfarbe fr kleinen Text
	m_clrNormalText	= 0;				// Schriftfarbe fr normalen Text
	m_clrSecondText = 0;				// Zweitfarbe fr normalen Text	
	
	m_clrGalaxySectorText = RGB(255,255, 255);	// Farbe der Systemnamen auf der Galaxiemap

	m_clrListMarkTextColor	= RGB(220,220,220);		// Farbe fr Text wenn dieser markiert ist
	m_clrListMarkPenColor	= RGB(140,196,203);		// Farbe fr Umrandung bei Markierung eines Eintrags in einer Liste
	m_clrRouteColor			= RGB(255,255,255);		// Farbe der Handels- und Ressourcenrouten

	for (int i = 0; i < 6; i++)
	{
		m_byGDIFontSize[i]		= 12;	// Fontgren fr GDI Darstellung
		m_byGDIPlusFontSize[i]	= 12;	// Fontgren fr GDI+ Darstellung
	}
	m_sFontName		= "Arial";			// Name der Schriftart
}