/*
 *   Copyright (C)2004-2011 Sir Pustekuchen
 *
 *   Author   :  Sir Pustekuchen
 *   Home     :  http://birth-of-the-empires.de
 *
 */
#pragma once

using namespace Gdiplus;
/**
 * Klasse beinhaltet und verwaltet alle Grafiken, welche fr Buttons benutzt werden. Ein Button fragt
 * bei einem CGraphicPool Objekt nach seiner zugehrigen Grafik an.
 *
 * @author Sir Pustekuchen
 * @version 0.0.1
 */
class CGraphicPool
{
public:
	/// Konstruktor
	/// @param path relativer Pfad in dem die Anwendung luft.
	CGraphicPool(const CString& path);

	/// Destruktor
	~CGraphicPool(void);

	// Funktionen
	/// Funktion liefert einen Zeiger auf eine Grafik.
	/// @param name Name der Grafik.
	CBitmap* GetGraphic(const CString &name);

	Bitmap* GetGDIGraphic(const CString &name);

private:
	// Attribute	
	/// Map welche zu einem Grafiknamen die passende Grafik bereithlt.
	CMap<CString, LPCSTR, CBitmap*, CBitmap*> m_Graphics;

	/// Map welche zu einem Grafiknamen die passende Grafik bereithlt.
	CMap<CString, LPCSTR, Bitmap*, Bitmap*> m_GDIGraphics;

	/// der relative Pfad, in welchem die Anwendung luft
	const CString m_strPath;
};
